diff --git a/Platforms/ARM/Juno/AcpiTables/Gtdt.aslc b/Platforms/ARM/Juno/AcpiTables/Gtdt.aslc
index 5e2daf9abb8344ff121dace4fa827838b10ac287..afffd4ac8e92888a554f60dda926c64132976229 100644
--- a/Platforms/ARM/Juno/AcpiTables/Gtdt.aslc
+++ b/Platforms/ARM/Juno/AcpiTables/Gtdt.aslc
@@ -25,10 +25,12 @@
 
 // Note: We could have a build flag that switches between memory mapped/non-memory mapped timer
 #ifdef SYSTEM_TIMER_BASE_ADDRESS
-  #define GTDT_GLOBAL_FLAGS             (GTDT_GLOBAL_FLAGS_MAPPED | GTDT_GLOBAL_FLAGS_LEVEL)
+#  define GTDT_GLOBAL_FLAGS             (GTDT_GLOBAL_FLAGS_MAPPED \
+                                         | GTDT_GLOBAL_FLAGS_LEVEL)
 #else
-  #define GTDT_GLOBAL_FLAGS             (GTDT_GLOBAL_FLAGS_NOT_MAPPED | GTDT_GLOBAL_FLAGS_LEVEL)
-  #define SYSTEM_TIMER_BASE_ADDRESS     0xFFFFFFFFFFFFFFFF
+#  define GTDT_GLOBAL_FLAGS             (GTDT_GLOBAL_FLAGS_NOT_MAPPED \
+                                         | GTDT_GLOBAL_FLAGS_LEVEL)
+#  define SYSTEM_TIMER_BASE_ADDRESS     0xFFFFFFFFFFFFFFFF
 #endif
 
 #define GTDT_TIMER_EDGE_TRIGGERED   EFI_ACPI_5_0_GTDT_TIMER_FLAG_TIMER_INTERRUPT_MODE
@@ -39,63 +41,66 @@
 #define GTDT_GTIMER_FLAGS           (GTDT_TIMER_ACTIVE_LOW | GTDT_TIMER_LEVEL_TRIGGERED)
 
 #ifdef ARM_JUNO_ACPI_5_0
-  EFI_ACPI_5_0_GENERIC_TIMER_DESCRIPTION_TABLE Gtdt = {
-    ARM_ACPI_HEADER(
-      EFI_ACPI_5_0_GENERIC_TIMER_DESCRIPTION_TABLE_SIGNATURE,
-      EFI_ACPI_5_0_GENERIC_TIMER_DESCRIPTION_TABLE,
-      EFI_ACPI_5_0_GENERIC_TIMER_DESCRIPTION_TABLE_REVISION
-    ),
-    SYSTEM_TIMER_BASE_ADDRESS,                    // UINT64  PhysicalAddress
-    GTDT_GLOBAL_FLAGS,                            // UINT32  GlobalFlags
-    FixedPcdGet32 (PcdArmArchTimerSecIntrNum),    // UINT32  SecurePL1TimerGSIV
-    GTDT_GTIMER_FLAGS,                            // UINT32  SecurePL1TimerFlags
-    FixedPcdGet32 (PcdArmArchTimerIntrNum),       // UINT32  NonSecurePL1TimerGSIV
-    GTDT_GTIMER_FLAGS,                            // UINT32  NonSecurePL1TimerFlags
-    FixedPcdGet32 (PcdArmArchTimerVirtIntrNum),   // UINT32  VirtualTimerGSIV
-    GTDT_GTIMER_FLAGS,                            // UINT32  VirtualTimerFlags
-    FixedPcdGet32 (PcdArmArchTimerHypIntrNum),    // UINT32  NonSecurePL2TimerGSIV
-    GTDT_GTIMER_FLAGS                             // UINT32  NonSecurePL2TimerFlags
-  };
+EFI_ACPI_5_0_GENERIC_TIMER_DESCRIPTION_TABLE    Gtdt = {
+  ARM_ACPI_HEADER (EFI_ACPI_5_0_GENERIC_TIMER_DESCRIPTION_TABLE_SIGNATURE,
+                   EFI_ACPI_5_0_GENERIC_TIMER_DESCRIPTION_TABLE,
+                   EFI_ACPI_5_0_GENERIC_TIMER_DESCRIPTION_TABLE_REVISION),
+  SYSTEM_TIMER_BASE_ADDRESS,                   // UINT64 PhysicalAddress
+  GTDT_GLOBAL_FLAGS,                           // UINT32 GlobalFlags
+  FixedPcdGet32 (PcdArmArchTimerSecIntrNum),   // UINT32 SecurePL1TimerGSIV
+  GTDT_GTIMER_FLAGS,                           // UINT32 SecurePL1TimerFlags
+  FixedPcdGet32 (PcdArmArchTimerIntrNum),      // UINT32 NonSecurePL1TimerGSIV
+  GTDT_GTIMER_FLAGS,                           // UINT32 NonSecurePL1TimerFlags
+  FixedPcdGet32 (PcdArmArchTimerVirtIntrNum),  // UINT32 VirtualTimerGSIV
+  GTDT_GTIMER_FLAGS,                           // UINT32 VirtualTimerFlags
+  FixedPcdGet32 (PcdArmArchTimerHypIntrNum),   // UINT32 NonSecurePL2TimerGSIV
+  GTDT_GTIMER_FLAGS                            // UINT32 NonSecurePL2TimerFlags
+};
 #else
-  #pragma pack (1)
+#  pragma pack (1)
 
-  typedef struct {
-    EFI_ACPI_5_1_GENERIC_TIMER_DESCRIPTION_TABLE          Gtdt;
-#if (JUNO_WATCHDOG_COUNT != 0)
-    EFI_ACPI_5_1_GTDT_SBSA_GENERIC_WATCHDOG_STRUCTURE     Watchdogs[JUNO_WATCHDOG_COUNT];
-#endif
-  } GENERIC_TIMER_DESCRIPTION_TABLE;
+typedef struct {
+  EFI_ACPI_5_1_GENERIC_TIMER_DESCRIPTION_TABLE Gtdt;
+#  if (JUNO_WATCHDOG_COUNT != 0)
+  EFI_ACPI_5_1_GTDT_SBSA_GENERIC_WATCHDOG_STRUCTURE
+    Watchdogs[JUNO_WATCHDOG_COUNT];
+#  endif
+} GENERIC_TIMER_DESCRIPTION_TABLE;
 
-  #pragma pack ()
+#  pragma pack ()
 
-  GENERIC_TIMER_DESCRIPTION_TABLE Gtdt = {
-    {
-      ARM_ACPI_HEADER(
-        EFI_ACPI_5_1_GENERIC_TIMER_DESCRIPTION_TABLE_SIGNATURE,
-        GENERIC_TIMER_DESCRIPTION_TABLE,
-        EFI_ACPI_5_1_GENERIC_TIMER_DESCRIPTION_TABLE_REVISION
-      ),
-      SYSTEM_TIMER_BASE_ADDRESS,                    // UINT64  PhysicalAddress
-      0,                                            // UINT32  Reserved
-      FixedPcdGet32 (PcdArmArchTimerSecIntrNum),    // UINT32  SecurePL1TimerGSIV
-      GTDT_GTIMER_FLAGS,                            // UINT32  SecurePL1TimerFlags
-      FixedPcdGet32 (PcdArmArchTimerIntrNum),       // UINT32  NonSecurePL1TimerGSIV
-      GTDT_GTIMER_FLAGS,                            // UINT32  NonSecurePL1TimerFlags
-      FixedPcdGet32 (PcdArmArchTimerVirtIntrNum),   // UINT32  VirtualTimerGSIV
-      GTDT_GTIMER_FLAGS,                            // UINT32  VirtualTimerFlags
-      FixedPcdGet32 (PcdArmArchTimerHypIntrNum),    // UINT32  NonSecurePL2TimerGSIV
-      GTDT_GTIMER_FLAGS,                            // UINT32  NonSecurePL2TimerFlags
-      0xFFFFFFFFFFFFFFFF,                           // UINT64  CntReadBasePhysicalAddress
-      JUNO_WATCHDOG_COUNT,                          // UINT32  PlatformTimerCount
-      sizeof (EFI_ACPI_5_1_GENERIC_TIMER_DESCRIPTION_TABLE) // UINT32 PlatfromTimerOffset
-    },
+GENERIC_TIMER_DESCRIPTION_TABLE  Gtdt = {
+  {
+    ARM_ACPI_HEADER (EFI_ACPI_5_1_GENERIC_TIMER_DESCRIPTION_TABLE_SIGNATURE,
+                     GENERIC_TIMER_DESCRIPTION_TABLE,
+                     EFI_ACPI_5_1_GENERIC_TIMER_DESCRIPTION_TABLE_REVISION),
+    SYSTEM_TIMER_BASE_ADDRESS,                   // UINT64  PhysicalAddress
+    0,                                           // UINT32  Reserved
+    FixedPcdGet32 (PcdArmArchTimerSecIntrNum),   // UINT32  SecurePL1TimerGSIV
+    GTDT_GTIMER_FLAGS,                           // UINT32  SecurePL1TimerFlags
+    FixedPcdGet32 (PcdArmArchTimerIntrNum),      // UINT32  NonSecurePL1TimerGSIV
+    GTDT_GTIMER_FLAGS,                           // UINT32  NonSecurePL1TimerFlags
+    FixedPcdGet32 (PcdArmArchTimerVirtIntrNum),  // UINT32  VirtualTimerGSIV
+    GTDT_GTIMER_FLAGS,                           // UINT32  VirtualTimerFlags
+    FixedPcdGet32 (PcdArmArchTimerHypIntrNum),   // UINT32  NonSecurePL2TimerGSIV
+    GTDT_GTIMER_FLAGS,                           // UINT32  NonSecurePL2TimerFlags
+    0xFFFFFFFFFFFFFFFF,                          // UINT64  CntReadBasePhysicalAddress
+    JUNO_WATCHDOG_COUNT,                         // UINT32  PlatformTimerCount
+    sizeof (EFI_ACPI_5_1_GENERIC_TIMER_DESCRIPTION_TABLE) // UINT32 PlatfromTimerOffset
+  },
 #if (JUNO_WATCHDOG_COUNT != 0)
-    {
-      EFI_ACPI_5_1_SBSA_GENERIC_WATCHDOG_STRUCTURE_INIT(
-          FixedPcdGet32 (PcdGenericWatchdogRefreshBase), FixedPcdGet32 (PcdGenericWatchdogControlBase), 93, 0),
-      EFI_ACPI_5_1_SBSA_GENERIC_WATCHDOG_STRUCTURE_INIT(
-          FixedPcdGet32 (PcdGenericWatchdogRefreshBase), FixedPcdGet32 (PcdGenericWatchdogControlBase), 94, EFI_ACPI_5_1_GTDT_SBSA_GENERIC_WATCHDOG_FLAG_SECURE_TIMER)
-    }
+  {
+    EFI_ACPI_5_1_SBSA_GENERIC_WATCHDOG_STRUCTURE_INIT (
+      FixedPcdGet32 (PcdGenericWatchdogRefreshBase),
+      FixedPcdGet32 (PcdGenericWatchdogControlBase),
+      93,
+      0),
+    EFI_ACPI_5_1_SBSA_GENERIC_WATCHDOG_STRUCTURE_INIT (
+      FixedPcdGet32 (PcdGenericWatchdogRefreshBase),
+      FixedPcdGet32 (PcdGenericWatchdogControlBase),
+      94,
+      EFI_ACPI_5_1_GTDT_SBSA_GENERIC_WATCHDOG_FLAG_SECURE_TIMER)
+  }
 #endif
   };
 #endif